#!/usr/local/bin/perl
require 'pioctl.pl';

sub rightstring {
    local ($encoded)=@_;
    local ($retstr);
    
    if ($encoded & &PRSFS_READ) {
        $retstr .= "r";
    }
    if ($encoded & &PRSFS_LOOKUP) {
        $retstr .= "l";
    }
    if ($encoded & &PRSFS_INSERT) {
        $retstr .= "i";
    }
    if ($encoded & &PRSFS_DELETE) {
        $retstr .= "d";
    }
    if ($encoded & &PRSFS_WRITE) {
        $retstr .= "w";
    }
    if ($encoded & &PRSFS_LOCK) {
        $retstr .= "k";
    }
    if ($encoded & &PRSFS_ADMINISTER) {
        $retstr .= "a";
    }
    return $retstr;
}
sub getacl {
    local ($file,*posacl,*negacl)=@_;
    local ($cmarg, $cmd, $result, $cmarg_out);
    local ($tnumpos, $tnumneg, $numpos, $numneg, $topline, $acl);
    $cmarg_out="\0" x 2048;
    $cmd=&VIOCGETAL;         
    $cmarg=pack("ppSS", 0, $cmarg_out, 0, 2048);
    $result=&pioctl($file, $cmd,  $cmarg, 0);
    return ($result) if ($result);


    ($tnumpos,$tnumneg,$acl)=split('\n',$cmarg_out,3);
    ($numpos)=split (/[ \t]+/,$tnumpos);
    ($numneg)=split (/[ \t]+/,$tnumneg);
    
    if ($numpos) {
        foreach $i (1..$numpos) {
            ($topline,$acl)=split('\n',$acl,2);
            ($group,$rights)=split('\t',$topline);
            $posacl{$group}=$rights;
        }                       
    }
    if ($numneg) {
        foreach $i (1..$numneg) {
            ($topline,$acl)=split('\n',$acl,2);
            ($group,$rights)=split('\t',$topline);
            $negacl{$group}=$rights;
        }
    }
}

        
1;
